/* testsharable.c : try to use sharable mmap /tmp/canvasbuf.imo */
/*                  by flip along horizontal axis imagepart between 100,100 and 200,200 */

/* compile with :
pushd /my/prive/projects/Canvas/v3
cc testsharable.c -o testsharable -W -Wall -I/my/c/include
*/

#include "defines.c"
#include "errordef.c"
#include "imo/orgbT.h"
#include "imo/imoheader.c"
#include "file/filebuf.c"

int main( void ){
  Filebuf	 fb		 ;
  imoheader*	 pih		 ;
  orgb*		 ro		 ;
  int		 wi		 ;
  T(orgb*)	 plino, plo, pro ;
  orgb		 o		 = { 255, 0, 0, 0 } ;
  int		 x, y		 ;

  verbose = 1 ;
  fb = GetMmappedFilebuf( "/tmp/canvasbuf.imo", 0 );
  pih = (imoheader*) fb.cont ;
  ro = (orgb*) (fb.cont + sizeof(imoheader)) ;
  wi = pih->wi ;
  if( wi      < 201 ){ ex("width too small"); }
  if( pih->hi < 201 ){ ex("height too small"); }
  v("wi=%d hi=%d", pih->wi, pih->hi );
  for( y=100, plino = ro+100*wi ; y < 200 ; y++, plino += wi ){
    for( x=100,plo=plino+100,pro=plino+199 ; x < 150 ; x++, plo++, pro-- ){
      *plo = *pro = o ;
/*      o = *pro ; *pro = *plo ; *plo = o ;*/
      }
    }
  plo = ro + 150 * wi + 150 ; o = *plo ;
  v("pixel at (150,150) is %d %d %d %d", o.o, o.r, o.g, o.b );
  return(0);
  }
